unit DE42u1;

(*Basis of dt3w.htm

  Most of this written 31Dec08, in day prior to ML's 1st NYE party,
  Ellie W having "retired".

  My first "proper", modal dialog included.

  Not perfect... but works as far as anyone reading
  dt3w.htm needs to be concerned.

  Falls over if data is....
    One partridge
    Two pears
    Three French hens...
  During "DoIt"... probably choking during attempt to decode date
     from source file line.

  But seems to work properly for valid data!! :-)

  *)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls; // See also "Uses DE42u2" inserted by Delphi further down the code.

const ver='31 Dec 2008';

type
  TDE42f1 = class(TForm)
    Label1: TLabel;
    buquit: TButton;
    buSpecSource: TButton;
    buSpecDest: TButton;
    buSpecCrit: TButton;
    buDoIt: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure buquitClick(Sender: TObject);
    procedure buSpecSourceClick(Sender: TObject);
    procedure buSpecDestClick(Sender: TObject);
    procedure buSpecCritClick(Sender: TObject);
    procedure buDoItClick(Sender: TObject);
  private
    { Private declarations }
    dfIn,dfOut:textfile;//file "handles" See http://sheepdogguides.com/dt2b.htm
       //for help with the ideas, if needed.
    boDFOutIsOpen,boDFInIsOpen:boolean;//see text published on
       //internet in connection with this application if the purpose
       //of these variables escapes you.
  public
    { Public declarations }
    wDate:word;
       //Will store the day, in Delphi's coding, which defines the boundary
       //between lines I want copied and those I don't want.
       //Will allow me about 30,000 days after 1/1/1996 before the
       //program has "Year 2000" problems.
       //(Word type data can hold 0-65535, the Delphi "name" for
       // 1/1/1996 was 35,065)
  end;

var
  DE42f1: TDE42f1;

implementation

uses DE42u2;

{$R *.DFM}
{$R+}

procedure TDE42f1.FormCreate(Sender: TObject);
begin
(*Next two lines cause application to open in a "sensible" position
  regardless of the resolution the user's screen is set to.
  All of the properties referenced, e.g. screen.height, are built
  in to the ordinary Delphi environment.

  Having these two lines in the code means that the form can be
  wherever you find it most convenient on your desktop while
  developiung the application*)
top:=(screen.height div 3)-(clientheight div 2);
left:=(screen.width div 2)-(clientwidth div 2);
caption:='DE41- Collect recent DS025 data. Ver: '+ver;
(*"Turn off" some buttons. Could be done with Object Inspector, but
   the fact they start "off" is clearer if it is done this way.*)
buSpecDest.enabled:=false;
buSpecCrit.enabled:=false;
buDoIt.enabled:=false;
//See text published on internet if you want to know more
//about the next two... or use your editor to scan through
//the lines where they appear....
boDFInIsOpen:=false;
boDFOutIsOpen:=false;
//Change default settings for some properties of OpenDialog1...
with OpenDialog1 do begin
InitialDir:='C:\'; // See http://sheepdogguides.com/dt3w.htm
FileName:='DS25WeDat.txt';// Sets the default name... useful only if
    // you will USUALLY want to open a PARTICULAR file.
Filter:='Text files|*.txt|All files|X*.txt';// Can also be set by a nice
    //simple editor in the Object inspector. If set this way, string
    //must consist of pairs of values separated by |'s (ascii 124).
    //The first member of the pair is what you'll see in the filter
    //pulldown, and the second is the filter which will be applied.
    //Note you can, if you have a reason, do things like setting a
    //filter which shows, say, text files with names beginning with
    //"X". (Filter would be X*.txt)... but be a little cautious about
    //"corrupting" Windows so far that users will become confused.
Options:=[ofReadOnly,ofEnableSizing];  // See http://sheepdogguides.com/dt3w.htm
end;//with OpenDialog...
SaveDialog1.Options:=[ofOverwritePrompt,ofHideReadOnly,
    ofNoReadOnlyReturn,ofEnableSizing];
end;

procedure TDE42f1.buquitClick(Sender: TObject);
begin
close;
end;

procedure TDE42f1.buSpecSourceClick(Sender: TObject);
(*Open source file, with DFIn as handle to it.*)
begin
if boDFInIsOpen then closefile(dfIn);//In case user has clicked on SpecSource before!
if OpenDialog1.execute then begin
    assignfile(dfIn,OpenDialog1.FileName);
    reset(dfIn);
    //if dfIn is an empty file, application needs to refuse to proceed
    boDFInIsOpen:=true;
    //Now enable button for next step..
    buSpecDest.enabled:=true;
    end;//if OpenDialog
end;

procedure TDE42f1.buSpecDestClick(Sender: TObject);
(*Open destination file, with DFOut as handle to it.
  If file already exists, "Do you want to over-write?"
  question asked during the spec of the output file,
  as part of what SaveDialog1 does for us. While
  not implemented here, code can be written
  to allow even fancier protection of an existing
  file's contents, or even open the file
  in such a way that the old contents remain
  and this application adds new material to
  the end of the file. ("Append")*)
begin
if boDFOutIsOpen then closefile(dfOut);//In case user has clicked on SpecSource before!
if SaveDialog1.execute then begin
   assignfile(dfOut,SaveDialog1.FileName);
   rewrite(dfOut);
   boDFOutIsOpen:=true;
   //Now enable button for next step..
   buSpecCrit.enabled:=true;
   showmessage('You aren''t done yet.'+chr(13)+
         'You''ve specified the destination file,'+chr(13)+
         'but must still click two more buttons.');
   end;//if SaveDialog
end;

procedure TDE42f1.buSpecCritClick(Sender: TObject);
(*Fills wDate with the day which is the last for
which I do NOT want lines copied.*)
begin
repeat
DE42DateInputf1.showmodal;
wDate:=DE42DateInputf1.wDateFromDE42DateInput;
//showmessage(inttostr(wDate));
(*It wasn't necessary to have the two "wDate" variables, "wDate" and
"wDateFromDE42DateInput", but they "accumulated" withing the code
over the course of developing the application and I decided not
to write out the slight inefficiency.*)
until true; (*If a test were put here, to be sure the date chosen
was suitable, then the "Get a date" dialog would be called
repeatedly until a date that passed the tests was returned.*)

wDate:=wDate-1;(*Massage value in wDate, to convert from "the first
date for which data is wanted", which the application's interface
asked us to supply, to "the last date for which lines of data should
not be transcribed", which is the criterion the application, internally,
is using.*)

//Now enable button for next step..
buDoIt.enabled:=true;
end;

procedure TDE42f1.buDoItClick(Sender: TObject);
//Variables used only within this procedure.
//As such, they are best declared WITHIN it.
var sLineJustRead:string;
    boFileEmpty:boolean;

//Note that the following function is made a
//part of the buDoItClick procdure. It isn't
//needed elsewhere, so there is no reason
//for it to be created at a higher level.
function boLineIsWanted(sTmp:string):boolean;
//Returns false until a line is found
//which is datestamped after wDate
//First a subroutine local to boLineIsWanted...
   function wDateInLine(sTmp:string):word;
   (*Returns date in Delphi code, having translated from TKB code.
     Returns 0 if there is a problem making the conversion.
     0 okay in context of this program because it will "look"
     like line is very, very, very old, and not the one to
     trigger the change over to "copy remaining lines to
     output file."*)
   var sDay,sMonth,sYear:string;
       wYear:word;
       bMonth,bDay:byte;
   begin //wDateInLine
   sYear:=copy(sTmp,3,2);//Year: 08=2008
   sMonth:=uppercase(sTmp[5]);//Month: a=Jan, b=Feb, etc
   sDay:=copy(sTmp,6,2);//Simply what it should be!

   wYear:=strtoint(sYear)+2000;
   bMonth:=ord(sMonth[1])-64;
   bDay:=strtoint(sDay);
   //showmessage(inttostr(bDay)+' '+inttostr(bMonth)+' '+inttostr(wYear));

   //The following should always execute without
   //an EConvertError... the date codes are
   //machine generated, but, just in case, say
   //a data file is corrupt, I will make sure
   //that there isn't an EConvertError...
  try
   result:=trunc(EncodeDate(wYear, bMonth, bDay));
      //trunc to change from DateTime data type, with fractional .000
     except on EConvertError do result:=0;
   end;//try.. except

   end;//wDateInLine
begin //boLineIsWanted
result:=false;
if uppercase(sTmp[1])<>'C' then begin
     if wDateInLine(sTmp)>wDate then result:=true;
  end;//1st char <> 'C'
//no else clause
end;


begin (*Start of buDoItClick's main block*)
(*Following note is not important for dt3w.htm readers....
 Note: If problem arises in boLineIsWanted, application sometimes
 "jumps out" of the OnClick handler, having written just the header
 line. Clicking the button again writes the header line again, and
 the the application tries to process the NEXT line in the file...
 nothing is done to put pointer back at start of file.*)
//Write header to destination
writeln(dfOut,'cmThis file created by DE41, version '+ver);

repeat //"Repeat" in our outline!
//---- read a line of source
readln(dfIn,sLineJustRead);
//---- set boFileEmpty... remember we discovered that
//    eof returns true after last datum read, it isn't
//    necessary to try to read past the end to get
//    "true" from eof
boFileEmpty:=eof(dfIn);
//Until a line wanted for destination is found, or boFileEmpty is true
until boFileEmpty or boLineIsWanted(sLineJustRead);
(*We've now made a good start, and got to the point where we
  now want to copy the rest of the source file to the destination*)
//While not boFileEmpty, do...
while not boFileEmpty do begin
//---- Write line to destination
writeln(dfOut,sLineJustRead);
//---- Read another line
readln(dfIn,sLineJustRead);
//---- Update the value in boFileEmpty
boFileEmpty:=eof(dfIn);
end;//of while loop
//Write last line out to destination
writeln(dfOut,sLineJustRead);
//Close files
closefile(dfIn);
  boDFInIsOpen:=false;
closefile(dfOut);
  boDFOutIsOpen:=false;
showmessage('Done!');//Always tell the user all went well.
end;

end.
